package bonephone;

import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;



/**
 * Implementation of the "Classic" bonephone CallPanel
 *
 * @author Jens Fiedler (jfi@fokus.gmd.de)
*/
public class berkomLargeCallPanel extends CallPanel 
{

	private JButton button1,button2;
	private JLabel  label1, label2, label3;
	//private JPanel  sp=null;
	private JLabel  sp=null;
	private JPanel  ssp1,ssp2,ssp3;
	private JLabel  portrait;


	public void setBackground(Color c) {
		super.setBackground(c);
		if (sp==null) return;
		sp.setBackground(c);
		ssp1.setBackground(c);
		ssp2.setBackground(c);
		ssp3.setBackground(c);
	}


	public berkomLargeCallPanel (Call c, boolean autoanswer) {
		super(c,autoanswer);
		setLayout(new BoxLayout(this, BoxLayout.X_AXIS));
		setAlignmentX((float)0.0);
		//sp=new JPanel();
		sp = new JLabel();

// XXX TEST
if (false) {
	sp = new JLabel();
	sp.setIcon(new ImageIcon("images.berkom/TestImage.gif"));
}
		ssp1=new JPanel();
		ssp2=new JPanel();
		ssp3=new JPanel();
		button1=new JButton();
		button2=new JButton();
		label1=new JLabel();
		label2=new JLabel();
		label3=new JLabel();
		label1.setAlignmentX(Container.LEFT_ALIGNMENT);
		label1.setIconTextGap(2);
		label2.setIconTextGap(2);
		portrait=new JLabel();
		button1.addActionListener(this);
		button1.setActionCommand("n");
		button2.addActionListener(this);
		button2.setActionCommand("n");
		Insets ix=new Insets(0,0,0,0);
		button1.setMargin(ix);
		button2.setMargin(ix);

		ssp3.setLayout(new BoxLayout(ssp3, BoxLayout.Y_AXIS));
		//ssp3.add(label1);

		ssp2.setLayout(new BoxLayout(ssp2, BoxLayout.Y_AXIS));
		//ssp2.add(new JLabel(icons[IconIdx_Blank]));
		//ssp2.add(button1);
		//ssp2.add(Box.createRigidArea(new Dimension(30,0)));
		//ssp2.add(button2);

		ssp1.setLayout(new BoxLayout(ssp1, BoxLayout.X_AXIS)); 

		//ssp1.add(label2);
		//ssp1.add(label3);
		ssp1.setAlignmentX(Container.LEFT_ALIGNMENT);
		ssp2.setAlignmentX(Container.LEFT_ALIGNMENT);
		ssp3.setAlignmentX(Container.CENTER_ALIGNMENT);

		sp.setBorder(null);
		sp.setBorder(BorderFactory.createEmptyBorder(1,2,1,2));
		//sp.setLayout(new BoxLayout(sp, BoxLayout.Y_AXIS));
		sp.setLayout(new BorderLayout(0,0));
		sp.add(ssp1, BorderLayout.WEST);
		sp.add(ssp2, BorderLayout.CENTER);
		sp.add(ssp3, BorderLayout.EAST);

		setBackground( new Color(7,175,193));

		// top, left, bottom, right
		ssp1.setBorder(BorderFactory.createEmptyBorder(3,60,0,10));
		//ssp1.add(Box.createRigidArea(new Dimension(60,0)));
		ssp1.add(portrait);
		//ssp1.add(Box.createRigidArea(new Dimension(10,0)));

		ssp2.add(Box.createRigidArea(new Dimension(0,6)));
		ssp2.add(label3);
		//ssp2.add(label2);
		ssp2.add(Box.createRigidArea(new Dimension(0,10)));
		ssp2.add(label1);

		ssp3.setBorder(BorderFactory.createEmptyBorder(4,5,0,5));
		ssp3.setLayout(new BoxLayout(ssp3, BoxLayout.Y_AXIS));
		//ssp3.add(Box.createRigidArea(new Dimension(10,10)));
		ssp3.add(button1);
		ssp3.add(Box.createRigidArea(new Dimension(0,3)));
		ssp3.add(button2);
		add(sp);

		//setLayout(null) for absolute positioning
		//portrait.setLocation(60,7);
		//button1.setLocation(362,3);
		//button2.setLocation(362,33);
		button1.setBorder(null);
		button2.setBorder(null);
		ssp1.setOpaque(false);
		ssp2.setOpaque(false);
		ssp3.setOpaque(false);
		label1.setOpaque(false);
		label2.setOpaque(false);
		label3.setOpaque(false);
		//label1.setLocation(140,15);
		//label2.setLocation(140,30);
		//label3.setLocation(140,40);

		label1.setText("Subject: "+mycall.getSubject());
		label1.setIcon(icons[IconIdx_Blank]);
		label1.setForeground(Color.blue);
		label2.setForeground(Color.yellow);
		label3.setForeground(Color.black);
		String name=mycall.getPeer();
		if (name.substring(0,4).equalsIgnoreCase("sip:")) name=name.substring(4);
		label3.setText(name);
//		portrait.setIcon(icons[IconIdx_Portrait]);
		portrait.setIcon(new ImageIcon("images.berkom/passbild.jpg"));

		update(c,null);
	}


	// This is called whenever the Call changes
	public void update (Observable o, Object arg) 	{
		if (autoAnswer()) return;
		int s=mycall.getState();
		    
		switch (s) {
			case IPT_State_Call.ST_CALLING: {
				sp.setIcon(new ImageIcon("images.berkom/warten.jpg"));
				//button1.setIcon(icons[IconIdx_Phonered]);
				button1.setIcon(new ImageIcon("images.berkom/warten_auflegen0.jpg"));
				button1.setRolloverIcon(new ImageIcon("images.berkom/warten_auflegen.jpg"));
				button1.setActionCommand("cancel");
				button1.setToolTipText("Hang Up");
				button2.setEnabled(false);
				button2.setVisible(false);
				button2.setActionCommand("nothing");
				label2.setIcon(icons[IconIdx_Sanduhr]);
				label2.setText(null);
				label2.setForeground(Color.black);
				//setBackground(Color.white);
	// XXX TEST
	if (false) {
		//button1.setRolloverIcon(icons[IconIdx_Sanduhr]);
		button1.setIcon(new ImageIcon("images.berkom/b1.gif"));
		button1.setPressedIcon(new ImageIcon("images.berkom/b1p.gif"));
		button1.setMargin(new Insets(0,0,0,0));
		button1.setBorder(new EmptyBorder(2,2,2,2));
		button1.setOpaque(false);
		//label2.setBackground(Color.gray);
		label2.setOpaque(false);
		sp.setOpaque(false);
	}
				break;					    	
			}
			case IPT_State_Call.ST_RINGING: {
				sp.setIcon(new ImageIcon("images.berkom/klingeln.jpg"));
				//button1.setIcon(icons[IconIdx_Phonered]);
				button1.setIcon(new ImageIcon("images.berkom/klingeln_auflegen0.jpg"));
				button1.setRolloverIcon(new ImageIcon("images.berkom/klingeln_auflegen.jpg"));
				button1.setActionCommand("cancel");
				button1.setToolTipText("Hang Up");
				button2.setEnabled(true);
				button2.setVisible(true);
				//button2.setIcon(icons[IconIdx_Phonegreen]);
				button2.setIcon(new ImageIcon("images.berkom/klingeln_annehmen0.jpg"));
				button2.setRolloverIcon(new ImageIcon("images.berkom/klingeln_annehmen.jpg"));
				button2.setToolTipText("Pick Up");
				button2.setActionCommand("accept");
				label2.setIcon(icons[IconIdx_Bell]);
				//setBackground(Color.white);
				break;					    	
			}
			case IPT_State_Call.ST_ACTIVE: {
				sp.setIcon(new ImageIcon("images.berkom/annehmen.jpg"));
				//button1.setIcon(icons[IconIdx_Phonered]);
				button1.setIcon(new ImageIcon("images.berkom/annehmen_auflegen0.jpg"));
				button1.setRolloverIcon(new ImageIcon("images.berkom/annehmen_auflegen.jpg"));
				button1.setActionCommand("hangup");
				button1.setToolTipText("Hang Up");
				button2.setEnabled(true);
				button2.setVisible(true);
				//button2.setIcon(icons[IconIdx_Crosslips]);   
				button2.setIcon(new ImageIcon("images.berkom/annehmen_stumm0.jpg"));
				button2.setRolloverIcon(new ImageIcon("images.berkom/annehmen_stumm.jpg"));
				button2.setToolTipText("Mute call");
				button2.setActionCommand("mute");
				label2.setIcon(icons[IconIdx_Redspot]);
				//setBackground(Color.green);
				break;					    	
			}
			case IPT_State_Call.ST_INACTIVE: {
				sp.setIcon(new ImageIcon("images.berkom/stumm.jpg"));
				//button1.setIcon(icons[IconIdx_Phonered]);
				button1.setIcon(new ImageIcon("images.berkom/stumm_auflegen0.jpg"));
				button1.setRolloverIcon(new ImageIcon("images.berkom/stumm_auflegen.jpg"));
				button1.setActionCommand("hangup");
				button1.setToolTipText("Hang Up");
				button2.setEnabled(true);
				button2.setVisible(true);
				//button2.setIcon(icons[IconIdx_Lips]);
				button2.setIcon(new ImageIcon("images.berkom/stumm_tonan0.jpg"));
				button2.setRolloverIcon(new ImageIcon("images.berkom/stumm_tonan.jpg"));
				button2.setToolTipText("Unmute call");
				button2.setActionCommand("unmute");
				label2.setIcon(icons[IconIdx_Crosslips]);
				//setBackground(Color.gray);
				break;	    	
			}
			case IPT_State_Call.ST_ERROR: {
				sp.setIcon(new ImageIcon("images.berkom/fehler.jpg"));
				//button1.setIcon(icons[IconIdx_Xbox]);
				button1.setIcon(new ImageIcon("images.berkom/fehler_auflegen0.jpg"));
				button1.setRolloverIcon(new ImageIcon("images.berkom/fehler_auflegen.jpg"));
				button1.setActionCommand("cancel");
				button1.setToolTipText("Dismiss");
				button2.setEnabled(false);
				button2.setVisible(false);
				button2.setActionCommand("nothing");
				label2.setIcon(icons[IconIdx_Lightning]);
				label2.setText(mycall.getError());
				label2.setForeground(Color.yellow);
				//setBackground(Color.red);
				break;					    	
			}
			case IPT_State_Call.ST_DELETE: {
				setVisible(false);
				break;					    	
			}
			case IPT_State_Call.ST_MUTING: {
				sp.setIcon(new ImageIcon("images.berkom/klingeln.jpg"));
				//button1.setIcon(icons[IconIdx_Phonered]);
				button1.setIcon(new ImageIcon("images.berkom/klingeln_auflegen0.jpg"));
				button1.setRolloverIcon(new ImageIcon("images.berkom/klingeln_auflegen.jpg"));
				button1.setActionCommand("hangup");
				button1.setToolTipText("Hang Up");
				button2.setEnabled(false);
				button2.setVisible(false);
				button2.setActionCommand("nothing");
				label2.setIcon(icons[IconIdx_Blackspot]);
				//setBackground(Color.white);
				break;					    	
			}
			case IPT_State_Call.ST_MISSED: {
				sp.setIcon(new ImageIcon("images.berkom/parken.jpg"));
				//button1.setIcon(icons[IconIdx_Xbox]);
				button1.setIcon(new ImageIcon("images.berkom/parken_auflegen0.jpg"));
				button1.setRolloverIcon(new ImageIcon("images.berkom/parken_auflegen.jpg"));
				button1.setActionCommand("cancel");
				button1.setToolTipText("Dismiss");
				button2.setEnabled(true);
				button2.setVisible(true);
				//button2.setIcon(icons[IconIdx_Rearrow]);
				button2.setIcon(new ImageIcon("images.berkom/parken_rueckruf0.jpg"));
				button2.setRolloverIcon(new ImageIcon("images.berkom/parken_rueckruf.jpg"));
				button2.setToolTipText("Call back");
				button2.setActionCommand("callback");
				label2.setIcon(icons[IconIdx_M]);
				//setBackground(Color.cyan);
				break;					    	
			}
			default: {
				sp.setIcon(new ImageIcon("images.berkom/fehler.jpg"));
				button1.setIcon(icons[IconIdx_Xbox]);
				button1.setActionCommand("cancel");
				button1.setToolTipText("Cancel");
				button2.setEnabled(false);
				button2.setVisible(false);
				button2.setActionCommand("nothing");
				label2.setIcon(icons[IconIdx_Lightning]);
				label2.setText("Unknown state "+s+". "+mycall.getError()+" ");
				//setBackground(Color.red);
	    	}
		} // switch

	}

}
